Program FlatsDatabaseV2;
const n = 100;             //Duomenu bazes talpinamu irasu maximalus kiekis
      roomsLim = 10;       //Nurodo maximalu kambariu skaiciu
      MasLim = 100;        //Nurodo maximalu masyvo elementu skaiciu
      priceLim = 10000000; //Nurodo maximalia suma
      meniuLim = 6;        //Nurodo maximalu meniu punktu skaiciu
      
Type Info = record   //Informacija apie buta
      part :String;  //Miesto rajonas
     rooms :Byte;
     price :Comp;
End;

Type FlaType = array[1..n] of Info;

//------------------------------------------------------------------------------

Function Number(check :String):Boolean;//Patikrina ar ivestas simbolis skaicius, jei taip igauna reiksme true, je ne false.
Var i :Integer;
Begin
  Number := True;
  For i := 1 to Length(check) do
    If (check[i] > '9') or (check[i] < '0')  then Number := False;
End;

Procedure NbValidator(Var check :String; value :LongInt);//Patikrina ar ivestas skaicius ne didesnis uz ivesta rezi
Var numb :LongInt;//numb - ivesta reiksme skaiciaus pavidale
Begin
  Repeat
    Val(Check, numb);
    If (Number(check) = false) or (numb > value) then
      Begin
        WriteLn('Sis parametras turi buti skaicius ne didesnis uz ',value);
        WriteLn('Prasome iveskite ji dar karta:');
        ReadLn(check);
     End;
  Until (Number(check) = true) and (numb <= value);//Praso ivesti simboli kol bus ivestas skaicius ne didesnis uz value
End;

//------------------------------------------------------------------------------

Procedure LineDrawer(len:Integer);//Briezia len ilgumo linija
Var i :Integer;
Begin
 For i := 1 to len do
    Write(chr(205));
End;

Procedure Reader ( Var Flat :FlaType; k, start :Integer);//Nuskato buto parametrus
Var check :String;
        i :Integer;
Begin
  For i := start to k do
    Begin
     WriteLn('Iveskite mikrorajona kuriame yra ',i,'-as butas');
     ReadLn(Flat[i].part);
     WriteLn('Ivekite kambariu skaiciu:');
     ReadLn(check);
     NbValidator(check, roomsLim);
     Val(Check, Flat[i].rooms);
     WriteLn('Iveskite buto kaina litais:');
     ReadLn(check);
     NbValidator(check,priceLim);
     Val(check, Flat[i].price);
    End;
End;

Procedure Writer (Flat :FlaType; k :Integer);// Isveda i ekrana turima duomenu baze
Var i :Integer;
Begin
  WriteLn('SIUO METU TURIMA DUOMENU BAZE:':50);
  WriteLn;
  If k = 0 then WriteLn('Tuscia.':38)
           else
              Begin
                Write(chr(201));
                LineDrawer(75);
                WriteLn(chr(187));
                For i := 1 to k do
                  Begin
                    WriteLn(chr(186),i,') Mikrorajonas: ',Flat[i].part :15,' Kambariu skaicius: ',Flat[i].rooms :2,' Kaina: ',Flat[i].price :9:2,'Lt',chr(186):3);
                    Write(chr(204));
                    LineDrawer(75);
                    WriteLn(chr(185));
                  End;
              End;
  WriteLn(chr(186),'PASIRINKITE VIENA IS MENIU PUNKTU:':50,chr(186):26);
  Write(chr(200));
  LineDrawer(75);
  WriteLn(chr(188));
  WriteLn;
  WriteLn;
End;

//------------------------------------------------------------------------------

Procedure Inserter(Var Flat :FlaType; Var k :Integer);// Iterpia irasa i duomenu baze
Var i ,poz :Integer;
     check :String;
Begin
If k = n then WriteLn('Duomenu baze pilna jus negalite prideti daugiau irasu')
         else
          Begin
            WriteLn('Iveskite pozicija i kuria noresite iterpti nauja irasa');
            ReadLn(check);
            NbValidator(check, k+1);
            Val(check, poz);
            For i := k downto poz do
              Begin
                Flat[i + 1].part := Flat[i].part;
                Flat[i + 1].rooms := Flat[i].rooms;
                Flat[i + 1].price := Flat[i].price;
             End;
           Reader(Flat,poz,poz);
           Inc(k);
           Writer(Flat, k);
         End;
End;

Procedure Remover(Var Flat :FlaType; Var k :Integer);// Istrina irasa is duomenu bazes
Var del, i :Integer;
     check :String;
Begin
  WriteLn('Iveskite iraso, kuri norite pasalinti pozicija:');
  ReadLn(check);
  NbValidator(check, k);
  Val(check, del);
  For i := del to k - 1 do
    Begin
      Flat[i].part := Flat[i + 1].part;
      Flat[i].rooms := Flat[i + 1].rooms;
      Flat[i].price := Flat[i + 1].price;
    End;
  Dec(k);
  Writer(Flat, k);
End;

Procedure Replacer(Var Flat :FlaType; Var k :Integer);//Pakeicia irasa duomenu bazeje
Var poz :Integer;
  check :String;
Begin
  WriteLn('Iveskite iraso, kuri norite pakeisti pozicija:');
  ReadLn(check);
  NbValidator(check, k);
  Val(check, poz);
  Reader(Flat,poz,poz);
  Writer(Flat, k);
End;

Procedure Finder(Var Flat :FlaType;  k :Integer);// Iesko iraso duomenu bazeje pagal kambariu skaiciu
Var quest, i :Integer;
       check :String;
     founded :Boolean;// jei elementas surastas faunded = true
Begin
  WriteLn('Iveskite kambariu skaiciu jusu ieskomame bute');
  ReadLn(check);
  NbValidator(check, roomsLim);
  Val(Check, quest);
  founded := False;
  WriteLn('PAIESKOS REZULTATAS:':50);
  For i := 1 to k do
    Begin
     If Flat[i].rooms = quest then
       Begin
         WriteLn('Mikrorajonas: ',Flat[i].part,' Kambariu skaicius: ',Flat[i].rooms,' kaina: ',Flat[i].price :0:2,'Lt');
         founded := true;
       End;
    End;
    If founded = False then WriteLn('Jusu ieskomo buto nera sarase.')
      else WriteLn('Paieska atlikta sekmingai');
End;

Procedure sorter(Var Flat :FlaType;  k :Integer);//Rusioja (Burbulo metodu) duomenu baze pagal kaina
Var i, j, y :Integer;
          x :Comp;
        str :String;
Begin
  WriteLn('RUSIAVIMO REZULTATAS':45);
  WriteLn;
  For i := 2 to k do
    For j := k downto i do
      If Flat[j-1].price > Flat[j].price then
        Begin
          x := Flat[j - 1].price;
          Flat[j-1].price := Flat[j].price ;
          Flat[j].price :=x ;
          
          y:= Flat[j - 1].rooms ;
          Flat[j - 1].rooms := Flat[j].rooms;
          Flat[j].rooms := y;
          
          str := Flat[j - 1].part;
          Flat[j - 1].part := Flat[j].part;
          Flat[j].part := str;
        End;
  Writer(Flat, k);
End;


Var   Flat :FlaType;
         k :Integer; // Irasu masyvo elementu skaicius
         x :Byte;
     check :String;//Kintamasis i kuri irasomi visi vartotojo ivedami duomenys, norint jos patikrinti
     Leave :Boolean;
BEGIN
  WriteLn('PARDUODAMU BUTU SARASAS':50);
  Write(' ':25);
  LineDrawer(27);
  WriteLn;
  WriteLn('Kiek irasu noresite ideti i duomenu baze? :');
  ReadLn(check);
  NbValidator(check, MasLim);
  Val(check, k);
  Reader(Flat,k,1);
  Writer(Flat, k);

  Leave := False ;
  While Leave = False do
    Begin
      WriteLn('MENIU':40);
      WriteLn;
      WriteLn('1: Iterpti irasa.');
      WriteLn('2: Trinti irasa.');
      WriteLn('3: Keisti irasa.');
      WriteLn('4: Ieskoti iraso.');
      WriteLn('5: Rusuoti dumenu baze pagal kaina.');
      WriteLn('6: Baigti darba');
      WriteLn;
      WriteLn('Iveskite atitinkama skaiciu:');
      ReadLn(check);
      NbValidator(check,meniuLim);
      Val(check, x);
      Case x of
        1:  Inserter(Flat,k);
        2:  Remover(Flat,k);
        3:  Replacer(Flat,k);
        4:  Finder(Flat,k);
        5:  sorter(Flat,k);
        6:  Leave := true;
      End;
   End;
END.

{ Progaramos autorius  E-mail  Vilniaus Universitetas MIF Informatika 1 Kursas.
Data 2008 12 05

Progarama kaupia informaciaj apie parduodamus butus. Informacija apie buta: Mikrorajonas, Kambariu skaicius, Kaina.
Leidziama atlikti suos veiksmus:
1. Ivesti irasa
2. Iterpti irasa i bet kuria pazicija
3. Istrinti irasa
4. Paeisti irasa
5. Surasti irasa
6. Rusioti irasus pagal kaina

Proceduros ir funkcijos
1. Number - funkcija igija reiksme false jei eiltes tipo parametras check sudarytas ne is skaiciu, priesingu atveju
jos reiksme islieka true.
2. NBValidator procedura patikrina ar skaicius ne didesnis uz parametra value taip pat kreipiasi i funkcija
Number jei nors vienas parametras netinkamas praso vartotojo ivesti skaiciu dar karta
3. Reader procedura nuskaito, no start iki k kartu, buto parametrus. visi buto parametrai nuskaitomi i String tipo kintamaji
check, check naudojamas isvestos reiksmes formato patiktinimui.
4. Writer  procedura isveda i ekrana turima duomenu baze.
5. Inserter  procedura iterpia nauja buta su jo parametrais i bet kutia vartotojo pasirinkta duomenu bazes vieta (poz).
Procedura pastumia irasus nuo poz i desine per viena elementa, atlaiswindama vieta naujam elementuj.
6. Remover pasalina irasus apie viena buta, pastumdama irasus nuo del i kaire, elemetas kurio pozicija del pasalinamas.
7. Replacer procedura priskyria naujo elemento reiksme senajam, tuo budu pakeisdama ji.
8. Finder vikdo elemento paieska duomenu bazeje.
9. LineDrawer Briezia len ilgumo linija

V2 Pakeitimai:
1. Pakeistas meniu, programa baigia darba nuspaudus 6 o ne bet koki skaiciu.
2. Pakeisti komentarai
3. Pagerintas interfeisas
4. Atlikti pakeitimai procedurose Inserter Remover Raplacer, siekian isvengti programos luzio kai vartotojas iveda
netinkama parametra(pozicija)
5. Pakeista procedura NBLengValid i procedura NBvelidator kuri tikrina ar skaicius ne didesnis uz rezi (NBLengValid
tikrino ar skaitmenu suma ne didesne uz rezi)}
